Description

in the attached patch :

 - update UnZip::ReadDir(): a file is added to the list only if all it's field are sets.

 - add the possiblilty to load a file knowing it's path

 - add search in the zip: Vector<String> UnZip::Search(String pattern)

currently, i have to do loop in each file in the zip in order to find a file knowing it's name.

        while(!(unzip.IsEof() || unzip.IsError())) {

            if(path == unzip.GetPath()))

                s = unzip.ReadFile();

            else

                unzip.SkipFile();

        }

it's usefull if we add this overload:

String UnZip::ReadFile(const char* path, Gate<int, int> progress = Null)

{

    for(int i = 0; i < file.GetCount(); i++)

    {

        if(file[i].path.IsEqual(path))

        {

            Seek(i);

            return ReadFile( progress );

        }

    }

    return String::GetVoid();

}

then the call will be :

    s = unzip.ReadFile(path);
History

#1 - 04/28/2017 11:58 PM - Zbigniew Rebacz

Why not?

for(int i = 0; i < file.GetCount(); i++) {}

for(const auto& f : file) {}

Just small tip :)

#2 - 04/30/2017 01:18 AM - Abdelghani Omari

thanks for the tips, i will consider that in future

but here the index is used in Seek(i)

#3 - 04/30/2017 01:37 AM - Abdelghani Omari

i think we shall add abbreviations for that "fa fca fab fdab" like fi, fj fib ..

fa = for(auto& a: @)

fcab = for(const auto& a: @) {\r\n\t\r\n}

#4 - 05/06/2017 12:09 AM - Abdelghani Omari

- File zip.patch added

- Subject changed from UnZip: allow reading file by path to plugin/Zip/UnZip: interface simplification & a little optimisation

- Description updated

- Priority changed from Low to Normal

#5 - 05/06/2017 04:49 PM - Abdelghani Omari

- File deleted (zip.patch)

#6 - 05/06/2017 04:50 PM - Abdelghani Omari

- File zip.patch added

#7 - 05/14/2017 02:12 PM - Miroslav Fidler

- Status changed from Patch ready to Approved

thanks

#8 - 05/14/2017 03:08 PM - Zbigniew Rebacz

- Target version set to Release 2017.2

Files

zip.patch 1.72 KB 05/06/2017 Abdelghani Omari
